/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __alembic_SurfaceAccessibleAbc_h__
#define __alembic_SurfaceAccessibleAbc_h__

namespace fe
{

/**************************************************************************//**
    @brief Alembic Surface Binding

	@ingroup alembic
*//***************************************************************************/
class FE_DL_EXPORT SurfaceAccessibleAbc:
	public SurfaceAccessibleJoint
{
	public:
								SurfaceAccessibleAbc(void)					{}
virtual							~SurfaceAccessibleAbc(void)					{}

								//* as SurfaceAccessibleI

virtual	BWORD					load(String a_filename,
										sp<Catalog> a_spSettings);

	private:

		enum	Mode
				{
					e_scan,
					e_mesh,
					e_joint
				};

		void					visit(Alembic::AbcGeom::IObject a_iObj);

		void					visitProperty(
										Alembic::AbcGeom::IScalarProperty
										a_properties,
										String a_indent);
		void					visitProperty(
										Alembic::AbcGeom::IArrayProperty
										a_properties,
										String a_indent);
		void					visitProperty(
										Alembic::AbcGeom::ICompoundProperty
										a_properties,
										String& a_rIndent);
		void					visitProperties(
										Alembic::AbcGeom::ICompoundProperty
										a_properties,
										String& a_rIndent);

		Real						m_fps;
		Real						m_minStep;
		Mode						m_mode;
		I32							m_xformCount;
		I32							m_meshCount;

		Alembic::AbcGeom::IArchive	m_archive;
		String						m_filename;
		SpatialTransform			m_refWorld;

		Array<SpatialVector>		m_pointArray;
		Array<I32>					m_vertCountArray;
		Array<I32>					m_vertIndexArray;
		Array< Array<I32> >			m_primVerts;
};

} // namespace

#endif /* __alembic_SurfaceAccessibleAbc_h__ */
