#! /usr/bin/python

import sys

if len(sys.argv) < 2:
	print "Usage: " + sys.argv[0] + " [-frame FRAME] [-frames START END] FILES..."
	exit()

filenames = []
frameRange = [ 0 ]
options = ""
argCount = len(sys.argv)

surfaceOptions = {}
surfaceOptions[0] = {}
surfaceOptions[1] = {}
surfaceOptions[2] = {}
surfaceOptions[3] = {}

surfaceCount = 0

argIndex = 1
while True:
	arg = sys.argv[argIndex]
	argIndex += 1

	if arg == "-frame":
		frame = int(sys.argv[argIndex])
		argIndex += 1

		frameRange = [ frame ]
	elif arg == "-frames":
		start = int(sys.argv[argIndex])
		end = int(sys.argv[argIndex + 1])
		argIndex += 2

		frameRange = range(start, end + 1)
	elif arg == "-options":
		options = sys.argv[argIndex]
		argIndex += 1
	else:
		filenames += [ arg ]

		surfaceOptions[surfaceCount] = options
		surfaceCount += 1

	if argIndex >= argCount:
		break;

import pyfe

fe = pyfe.Context()
fe.manage("fexOperatorDL")
fe.manage("fexOpLabDL")

surfaceNormalOp = fe.create("SurfaceNormalOp")
surfaceViewerOp = fe.create("SurfaceViewerOp")

surfaces = {}
surfaces[0] = {}
surfaces[1] = {}
surfaces[2] = {}
surfaces[3] = {}

while True:
	for frame in frameRange:
		fe.setFrame(frame)

		# cache frames as used
		for surfaceIndex in range(4):
			if len(filenames) > surfaceIndex and filenames[surfaceIndex] != "":
				if not frame in surfaces[surfaceIndex]:
					filename = filenames[surfaceIndex].replace("$F", str(frame))
					surfaceName = str(surfaceIndex)+":"+str(frame)
					surfaces[surfaceIndex][frame] = fe.load(filename, surfaceName, surfaceOptions[surfaceIndex])

		# use None whenever frame is missing
		current = { }
		for surfaceIndex in range(4):
			if frame in surfaces[surfaceIndex]:
				current[surfaceIndex] = surfaces[surfaceIndex][frame]
#				current[surfaceIndex] = surfaceNormalOp(surfaces[surfaceIndex][frame])
			else:
				current[surfaceIndex] = None

		surfaceViewerOp(current[0], current[1], current[2], current[3])

		if int(surfaceViewerOp["finished"]):
			exit()
